unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient,
  IdHTTP, IdCookieManager, StdCtrls, IdServerIOHandler, IdSSLOpenSSL,
  IdIOHandler, IdIOHandlerSocket;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    procedure FormCreate(Sender: TObject);
    procedure IdHTTP1Redirect(Sender: TObject; var dest: String;
      var NumRedirect: Integer; var Handled: Boolean;
      var VMethod: TIdHTTPMethod);
  private
    { Private declarations }
    compose_url:string;
    IdHTTP1: TIdHTTP;
    IdCookieManager1: TIdCookieManager;
    IdSSLIOHandlerSocket1: TIdSSLIOHandlerSocketOpenSSL;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses strutils;

procedure TForm1.FormCreate(Sender: TObject);
var
  Params: TStringList;
  HTML, loginurl, signinurl, userid: String;
  count:integer;
  cookies:tstringlist;

{  procedure setcookies;
  var j:integer;
  begin
    count:=IdCookieManager1.CookieCollection.count;
    for j:=1 to count do
      IdHTTP1.Request.RawHeaders.Add('Cookie'+IdHTTP1.Request.RawHeaders.NameValueSeparator+IdCookieManager1.CookieCollection.Items[j-1].CookieText);
  end;

  procedure getcookies;
  var j:integer;
  begin
    count:=IdCookieManager1.CookieCollection.count;// get them
    for j:=1 to count do
      cookies.Add(IdCookieManager1.CookieCollection.Items[j-1].CookieText);
  end;{}

  procedure setcookies;
  var j:integer; s:string;
  begin
    count:=cookies.count;
    s:='';
    for j:=1 to count do
    begin
      IdCookieManager1.AddCookie(cookies[j-1],IdHTTP1.url.Host);
      s:=s+'; '+cookies[j-1];
    end;
    if s<>'' then
    begin
      delete(s,1,2);
      IdHTTP1.Request.CustomHeaders.Values['Cookie']:=s;
      //('Cookie'+IdHTTP1.Request.RawHeaders.NameValueSeparator+s);
    end;{}
  end;

  procedure extractcookie(cookie:string; var name,value:string);
  var i,k:integer;
  begin
    i:=pos('=',cookie);
    k:=pos(';',cookie);
     if k=0 then k:=length(cookie);
    if i>0 then
    begin
      name:=copy(cookie,1,i-1);
      value:=copy(cookie,i+1,k-i-1);
    end      else
    begin
      name:='';
      value:='';
    end;
  end;

  procedure savecookies;
  var j:integer;
      name,value:String;
  begin
    count:=IdCookieManager1.CookieCollection.count;
    for j:=1 to count do
    begin
      extractcookie(IdCookieManager1.CookieCollection.Items[j-1].CookieText,name,value);
      cookies.Values[name]:=value;
    end;
//   IdCookieManager1.CookieCollection.Clear;
  end;

  procedure saveit(name:string);
  begin
    with tfilestream.create(name,fmcreate) do
    try
      write(pansichar(html)^,length(html));
    finally
      free;
    end;
  end;

  procedure updatecookies;
  var _cookies:tstringlist;
      i:integer;
      name,value:string;
  begin
    _Cookies := TStringList.Create;
    IdHTTP1.Response.RawHeaders.Extract('Set-cookie', _Cookies);
    for i := 0 to _Cookies.Count - 1 do
    begin
//      IdCookieManager1.AddCookie(_Cookies[i], IdHTTP1.URL.Host);
      extractcookie(_Cookies[i],name,value);
      cookies.Values[name]:=value;
    end;
    _cookies.free;
  end;

  function checkcookies:boolean;
  var _cookies:tstringlist;
  begin
    _Cookies := TStringList.Create;
    IdHTTP1.Response.RawHeaders.Extract('Set-cookie', _Cookies);
    result:=_Cookies.Count>0;
    _cookies.free;
  end;

  function extractValue:string;
  var isQuoted:boolean;
      ending:char;
  begin
    result:='';
    isQuoted:=html[1]='"';
    if isQuoted then
    begin
      delete(html,1,1);
      ending:='"';
    end         else
      ending:=' ';// might also be tab or otehr characters. need to check the rfc
    while html[1]<>ending do
    begin
      result:=result+html[1];
      delete(html,1,1);
    end;
  end;

  procedure initializeForm(login:boolean);
  var i,j:integer;
      name,value:string;
  begin
    params.clear;
    while html<>'' do
    begin
      i:=pos('<input ',html);
      if i=0 then break;// no more inputs
      delete(html,1,i+5);
      i:=pos(' name=',html);
      if i=0 then continue;// input type for ex button
      j:=pos(' value=',html);
      if i<j then
      begin
        delete(html,1,i+5);
        name:=extractvalue;
        j:=pos(' value=',html);
        delete(html,1,j+6);
        value:=extractvalue;
      end    else
      begin
        delete(html,1,j+6);
        value:=extractvalue;
        i:=pos(' name=',html);
        delete(html,1,i+5);
        name:=extractvalue;
      end;
      if login then
      begin
        if name='login' then value:=userid;
        if name='passwd' then value:=InputBox('Login to yahoo', 'Password', '')
      end      else
      begin
        if name='SEND' then value:='1';//damn js hacks
        if name='To' then value:=inputbox('Send email', 'TO address', '');
        if name='Subj' then value:=inputbox('Send email', 'SUBJECT', 'test') //!! this is a must, otherwise yahoo will insert an ugly message which I will not handle now
        // the textarea will not be parsed by this method so will be filled separatly later
      end;
      Params.Values[name] := value;
    end;
  end;

begin
  IdSSLIOHandlerSocket1:=TIdSSLIOHandlerSocketOpenSSL.Create(self);
  idhttp1:=TIdHttp.Create(self);
  idhttp1.AllowCookies:=true;
  idhttp1.HandleRedirects:=true;
  idhttp1.HTTPOptions:=[hoForceEncodeParams];
  idhttp1.IOHandler:=IdSSLIOHandlerSocket1;
  IdSSLIOHandlerSocket1.SSLOptions.Method:=sslvSSLv23;
  IdSSLIOHandlerSocket1.SSLOptions.Mode:=sslmClient;
  IdCookieManager1:=TIdCookieManager.Create(self);
  idhttp1.CookieManager:=IdCookieManager1;

  signinurl:='http://mail.yahoo.com';
  // the above is used to get the login page (this is the link from the "sign in" link.
  // you have to emulate a browser, so you need to do all steps. this is a good idea to do
  // since all redirects might set cookies that you will probably need

  loginurl:='https://login.yahoo.com/config/login?';
  // the above is the login url. this is the url from the action property of the form; this is where
  // the login request will be sent

  userid:=InputBox('Login to yahoo', 'Username', '');

  Params := TStringList.Create;
  try
    cookies:=tstringlist.Create;

    html:=idhttp1.Get(signinurl);// first get; get first cookie(s)
    savecookies;

    delete(html,1,pos('name="login_form"',html));
    delete(html,pos('</form>',html),length(html));

    initializeForm(true);

    setCookies;
    HTML := IdHTTP1.Post(loginurl, Params);// now do the log in
    updatecookies;

    setcookies;
    HTML := IdHTTP1.Get('http://mail.yahoo.com');// this is because:
//    assert(checkcookies); no cookies set here
    // "If you are seeing this page, your browser settings prevent you from automatically
    // redirecting to a new URL."

    count:=pos('Welcome, <strong>',html)+17;// 17=length(Welcome, <strong>)
    count:=posex(userid+'</strong>',html,count)-count;
    if count=1 then
    begin  // we are logged in
      setcookies;// cookies must be set before every request
      HTML := IdHTTP1.Get(compose_url+'/ym/Compose?YY=94329&inc=25&order=down&sort=date&pos=0&view=a&head=b&box=Inbox');
      updatecookies;

      delete(html,1,pos('name="Compose"',html));

      initializeForm(false);
      Params.Values['Body'] := inputbox('Send email', 'Email message', 'testing yahoo email by ciuly');

      setCookies;
      HTML := IdHTTP1.Post(compose_url+'/ym/Compose?YY=42300&order=down&sort=date&pos=0&view=a', Params);// now send the message
    end               else
      showmessage('login failed');

  except
    on e: EIdHTTPProtocolException do
    begin
      memo1.lines.add(idHTTP1.response.ResponseText);
      memo1.lines.add(e.ErrorMessage);
    end;
  end;
  Params.Free;
  memo1.Lines.Text:=html;
end;

procedure TForm1.IdHTTP1Redirect(Sender: TObject; var dest: String;
  var NumRedirect: Integer; var Handled: Boolean;
  var VMethod: TIdHTTPMethod);
begin
  compose_url:=dest;
  delete(compose_url,posex('/',compose_url,8),length(compose_url));// 8= length(http://)+1
end;

end.
